# Interface yii\web\UrlRuleInterface

Implemented by | yii\rest\UrlRule, yii\web\CompositeUrlRule, yii\web\GroupUrlRule, yii\web\UrlRule
Available since version | 2.0
Source Code | https://github.com/yiisoft/yii2/blob/master/framework/web/UrlRuleInterface.php

UrlRuleInterface is the interface that should be implemented by URL rule classes.

## Public Methods

Hide inherited methods

Method | Description | Defined By
--- | --- | ---
createUrl() | Creates a URL according to the given route and parameters. | yii\web\UrlRuleInterface
parseRequest() | Parses the given request and returns the corresponding route and parameters. | yii\web\UrlRuleInterface

## Method Details

createUrl() public abstract method

Creates a URL according to the given route and parameters.

public abstract string|boolean createUrl ( $manager, $route, $params )
$manager | yii\web\UrlManager | The URL manager
$route | string | The route. It should not have slashes at the beginning or the end.
$params | array | The parameters
return | string|boolean | The created URL, or false if this rule cannot be used for creating this URL.

parseRequest() public abstract method

Parses the given request and returns the corresponding route and parameters.

public abstract array|boolean parseRequest ( $manager, $request )
$manager | yii\web\UrlManager | The URL manager
$request | yii\web\Request | The request component
return | array|boolean | The parsing result. The route and the parameters are returned as an array. If false, it means this rule cannot be used to parse this path info.